﻿<template>
    <form class="form"
          novalidate
          @submit.prevent="handleSubmit"
          enctype="multipart/form-data">

        <FormInput v-model="oldPasswd"
                   type="password"
                   name="password"
                   :ref="addFormInputRef"
                   :label="t('member.form.OldPassword')"
                   @validated="handleValidation" />

        <FormRow>
            <FormInput v-model="passwd"
                       type="password"
                       name="password1"
                       :ref="addFormInputRef"
                       :label="t('member.form.NewPassword')"
                       @validated="handleValidation" />
            <FormInput v-model="passwd2"
                       type="password"
                       name="password2"
                       :ref="addFormInputRef"
                       :label="t('member.form.password2')"
                       @validated="handleValidation" />
        </FormRow>

        <button class="form__submit btn btn--fullscreen" type="submit">
            {{ t("global.actions.update") }}
        </button>
    </form>
</template>

<script lang="ts" setup>
    import FormInput from "@/components/forms/FormInput.vue";
    import FormRow from "@/components/forms/FormRow.vue";
    import { ref } from "vue";
    import { useI18n } from "vue3-i18n";
    import { Status } from "@/validation";
    import { notifyError } from "@/notify"

    const { t } = useI18n();

    // eslint-disable-next-line
    const emit = defineEmits<{
        (event: "formSubmit", password: string, oldPassword: string): void
    }>()

    const passwd2 = ref<string>("")
    const passwd = ref<string>("")
    const oldPasswd = ref<string>("")
    const formInputs = ref<any[]>([])
    const inputValidationStatuses: any = {}
    const regexPassword = /^(?=.*[a-z])(?=.*[A-Z])(?=.*[^a-zA-Z])(?!.*(.).*\1).{10,}$/

    function addFormInputRef(ref: typeof FormInput) {
        if (!formInputs.value.includes(ref) && ref)
            formInputs.value.push(ref)
    }


    async function handleValidation(name: string, validationStatus: Status) {
        inputValidationStatuses[name] = validationStatus.valid
    }

    async function handleSubmit() {
        formInputs.value.forEach((x: typeof FormInput) => x.validateInput())
        if (Object.values(inputValidationStatuses).some(x => x === false)) {
            notifyError(t('global.formErrorNotification'))
            return
        }

        if (passwd.value !== passwd2.value) {
            notifyError(t('validation.member.add.passwordMissmatch'))
            // TODO: Mettre les champs en rouge
            return
        }

        if (!regexPassword.test(passwd.value)) {
            notifyError(t('validation.member.add.passwordException'))
            return
        }

        emit("formSubmit", passwd.value, oldPasswd.value)
    }
</script>